//+------------------------------------------------------------------+
//|                                            AverageRange_v1.4.mq4 |
//|                                         Copyright 2020, NickBixy |
//|             https://www.forexfactory.com/showthread.php?t=904734 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, NickBixy"
#property link      "https://www.forexfactory.com/showthread.php?t=904734"
//#property version   "1.00"
#property strict
#property indicator_chart_window

enum pipPointChoice
  {
   Pips,//Pips
   Points,//Points
  };

enum yesnoChoiceToggle
  {
   No,
   Yes
  };

input string adrHeader="-----------------Average Range Settings------------------------------------------";//----- Average Range Settings
input ENUM_TIMEFRAMES timeFrame=PERIOD_D1;//TimeFrame
input int period=10;//Period
input pipPointChoice pipPointSelection=Pips;//Pips/Points?
input yesnoChoiceToggle showInfoLabels=Yes;//Show Info Labels
input string lineLabelHeader="-----------------Line/Label Customize  Settings------------------------------------------";//----- Line/Label Customize  Settings
input yesnoChoiceToggle roundNearest=Yes;//Rounded Off To The Nearest Integer?
input int decimalPlaces=0;//Number Of Digits After Decimal Point (0-8).
input string Font="Arial";//Font
input int labelFontSize=7;//Font Size
input int ShiftLabel=20;//Label Shift +move right -move left
input string highHeader="High Line/Label Customize--------------------------------------------";//----- High Line/Label Customize
input string customHighMSG="Daily Range High";//High Label custom MSG
input ENUM_LINE_STYLE highLineStyle=STYLE_SOLID;//High Line Style
input int highLineWidth=2;//High Line Width
input color highLineClr=clrOrange;//High Line Color
input color highLabelClr=clrOrange;//High Label Color
input string lowHeader="Low Line/Label Customize--------------------------------------------";//----- Low Line/Label Customize
input string customLowMSG="Daily Range Low";//Low Label custom MSG
input ENUM_LINE_STYLE lowLineStyle=STYLE_SOLID;//Low Line Style
input int lowLineWidth=2;//Low Line Width
input color lowLineClr=clrOrange;//Low Line Color
input color lowLabelClr=clrOrange;//Low Label Color
string indiName;
//+------------------------------------------------------------------+
int OnInit()
  {
   if(period<1)
     {
      Alert("Period can't be less than 1");
     }
   ObjectsDeleteAll(0,"ARL",0,OBJ_TREND) ;
   ObjectsDeleteAll(0,"ARL",0,OBJ_TEXT) ;
   indiName="ARL"+" "+EnumToString(timeFrame)+" "+(string)period;
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
void deinit()
  {
   ObjectsDeleteAll(0,"ARL",0,OBJ_TREND) ;
   ObjectsDeleteAll(0,"ARL",0,OBJ_TEXT) ;
  }
//+------------------------------------------------------------------+
int start()
  {
   DrawRangeLines();
   return 0;
  }
//+------------------------------------------------------------------+
void DrawRangeLines()
  {
   string avgRange="";
   string todayRange="";
   string highDis="";
   string lowDis="";
   string ratio="";

   string highMSG="";
   string lowMSG="";
   if(showInfoLabels==Yes)
     {
      avgRange=  "(A"+(string)period+"="+DoubleToString(GetAverageRangeNumPeriodsPipsPoints(),decimalPlaces)+")";
      todayRange="(C="+DoubleToString(GetTodayRangePipsPoints(),decimalPlaces)+")";
      highDis=   "(D="+DoubleToString(GetBidAverageRangeDistancePipsPoints(GetAverageRangeHigh()),decimalPlaces)+")";
      lowDis=    "(D="+DoubleToString(GetBidAverageRangeDistancePipsPoints(GetAverageRangeLow()),decimalPlaces)+")";
      ratio=     "(P="+DoubleToString(GetAverageRangeRatioPipsPoints(),decimalPlaces)+"%)";

      highMSG=customHighMSG+avgRange+todayRange+ratio+highDis;
      lowMSG=customLowMSG+avgRange+todayRange+ratio+lowDis;
     }
   else
     {     
      highMSG=customHighMSG;
      lowMSG=customLowMSG;
     }


//HIGH Range Line
   if(ObjectFind(indiName+" High") != 0)
     {
      ObjectCreate(indiName+" High",OBJ_TREND,0,iTime(NULL,timeFrame,0),GetAverageRangeHigh(),Time[0]+Period()*60,GetAverageRangeHigh());
      ObjectSet(indiName+" High",OBJPROP_RAY,true);
      ObjectSet(indiName+" High",OBJPROP_COLOR,highLineClr);
      ObjectSet(indiName+" High",OBJPROP_STYLE,highLineStyle);
      ObjectSet(indiName+" High",OBJPROP_WIDTH,highLineWidth);
      ObjectSet(indiName+" High",OBJPROP_BACK,true);
      ObjectSet(indiName+" High",OBJPROP_SELECTED,false);
      ObjectSet(indiName+" High",OBJPROP_SELECTABLE,false);
     }
   else
     {
      ObjectMove(indiName+" High",0,iTime(NULL,timeFrame,0),GetAverageRangeHigh());
      ObjectMove(indiName+" High",1,Time[0]+Period()*60,GetAverageRangeHigh());
     }
//LOW Range Line
   if(ObjectFind(indiName+" LOW") != 0)
     {
      ObjectCreate(indiName+" LOW",OBJ_TREND,0,iTime(NULL,timeFrame,0),GetAverageRangeLow(),Time[0]+Period()*60,GetAverageRangeLow());
      ObjectSet(indiName+" LOW",OBJPROP_RAY,true);
      ObjectSet(indiName+" LOW",OBJPROP_COLOR,lowLineClr);
      ObjectSet(indiName+" LOW",OBJPROP_STYLE,lowLineStyle);
      ObjectSet(indiName+" LOW",OBJPROP_WIDTH,lowLineWidth);
      ObjectSet(indiName+" LOW",OBJPROP_BACK,true);
      ObjectSet(indiName+" LOW",OBJPROP_SELECTED,false);
      ObjectSet(indiName+" LOW",OBJPROP_SELECTABLE,false);
     }
   else
     {
      ObjectMove(indiName+" LOW",0,iTime(NULL,timeFrame,0),GetAverageRangeLow());
      ObjectMove(indiName+" LOW",1,Time[0]+Period()*60,GetAverageRangeLow());
     }
///////////////////////////////////////////////////////////
//HIGH Range LABEL
   if(ObjectFind(indiName+" HighLabel") != 0)
     {
      ObjectCreate(indiName+" HighLabel",OBJ_TEXT,0,Time[0]+Period()*60*ShiftLabel,GetAverageRangeHigh());
      ObjectSetText(indiName+" HighLabel",highMSG,labelFontSize,Font,highLabelClr);
      ObjectSet(indiName+" HighLabel",OBJPROP_BACK,true);
      ObjectSet(indiName+" HighLabel",OBJPROP_SELECTED,false);
      ObjectSet(indiName+" HighLabel",OBJPROP_SELECTABLE,false);
     }
   else
     {
      ObjectMove(indiName+" HighLabel", 0,Time[0]+Period()*60*ShiftLabel,GetAverageRangeHigh());
      ObjectSetText(indiName+" HighLabel",highMSG,labelFontSize,Font,highLabelClr);
     }
//LOW Range LABEL
   if(ObjectFind(indiName+" LowLabel") != 0)
     {
      ObjectCreate(indiName+" LowLabel",OBJ_TEXT,0,Time[0]+Period()*60*ShiftLabel,GetAverageRangeLow());
      ObjectSetText(indiName+" LowLabel",lowMSG,labelFontSize,Font,lowLabelClr);
      ObjectSet(indiName+" LowLabel",OBJPROP_BACK,true);
      ObjectSet(indiName+" LowLabel",OBJPROP_SELECTED,false);
      ObjectSet(indiName+" LowLabel",OBJPROP_SELECTABLE,false);
     }
   else
     {
      ObjectMove(indiName+" LowLabel", 0,Time[0]+Period()*60*ShiftLabel,GetAverageRangeLow());
      ObjectSetText(indiName+" LowLabel",lowMSG,labelFontSize,Font,lowLabelClr);
     }
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
double GetBidAverageRangeDistancePipsPoints(double rangeValue)
  {
   double value=0;
   double bid=MarketInfo(NULL,MODE_BID);
   double points=MarketInfo(NULL,MODE_POINT);

   if(rangeValue!=0 && rangeValue!=NULL && bid!=0 && bid!=NULL)
     {
      value=(rangeValue-bid)/points;
     }

   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor();
        }
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetAverageRangeRatioPipsPoints()
  {
   double value=0;

   double todayRange=GetTodayRangePipsPoints();
   double averageRangeNumPeriods=GetAverageRangeNumPeriodsPipsPoints();

   if((todayRange!=0 && todayRange!=NULL) && (averageRangeNumPeriods!=0 && averageRangeNumPeriods!=NULL))
     {
      value=(todayRange/averageRangeNumPeriods)*100;
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
int PipsToPointFactor()
  {
   int point=1;

   if(Digits==5 || Digits==3)
     {
      point=10; //1 pip to 10 point if 5 digit
     } //Check whether it's a 5 digit broker (3 digits for Yen)
   else
      if(Digits==4 || Digits==2)
        {
         point=1; //1 pip to 1 point if 4 digit
        }
      else
         if(Digits==1)
           {
            point=1;
           }

   return(point);
  }
//+------------------------------------------------------------------+
double GetAverageRangeNumPeriodsPipsPoints()
  {
   double value=GetAverageRangeNumPeriods();
   double points=MarketInfo(NULL,MODE_POINT);

   if(value!=0 && value!=NULL && points!=0 && points!=NULL)
     {
      value=value/points;
     }


   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor();
        }
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetTodayRangePipsPoints()
  {
   double value=0;
   double points=MarketInfo(NULL,MODE_POINT);
   double high=iHigh(NULL,timeFrame,0);
   double low=iLow(NULL,timeFrame,0);
   value=MathAbs(high-low);

   if(value!=0 && value!=NULL && points!=0 && points!=NULL)
     {
      value=value/points;
     }


   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor();
        }
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetAverageRangeNumPeriods()
  {
   double result=0;
   double averageRange=0;
   for(int i=1; i<=period; i++)
     {
      double high=iHigh(NULL,timeFrame,i);
      double low=iLow(NULL,timeFrame,i);
      averageRange+=high-low;
     }
   return result=averageRange/period;
  }
//+------------------------------------------------------------------+
double GetTimeFrameHighestHigh()
  {
   return iHigh(NULL,timeFrame,0);
  }
//+------------------------------------------------------------------+
double GetTimeFrameLowestLow()
  {
   return iLow(NULL,timeFrame,0);
  }
//+------------------------------------------------------------------+
double GetAverageRangeHigh()
  {
   double todayHigh=iHigh(NULL,timeFrame,0);
   double todayLow=iLow(NULL,timeFrame,0);

   double rangeHigh=GetTimeFrameLowestLow()+GetAverageRangeNumPeriods();;

   double averageRange=GetAverageRangeNumPeriods();

   if(todayHigh - todayLow > averageRange)
     {
      if(MarketInfo(NULL,MODE_BID) >= todayHigh- (todayHigh-todayLow)/2)
        {
         rangeHigh = todayLow + averageRange;

        }
      else
        {
         rangeHigh  = todayHigh;
        }
     }

   return rangeHigh;
  }
//+------------------------------------------------------------------+
double GetAverageRangeLow()
  {
   double todayHigh=iHigh(NULL,timeFrame,0);
   double todayLow=iLow(NULL,timeFrame,0);

   double rangeLow=GetTimeFrameHighestHigh()-GetAverageRangeNumPeriods();

   double averageRange=GetAverageRangeNumPeriods();

   if(todayHigh - todayLow > averageRange)
     {
      if(MarketInfo(NULL,MODE_BID) >= todayHigh- (todayHigh-todayLow)/2)
        {
         rangeLow  = todayLow;
        }
      else
        {
         rangeLow = todayHigh - averageRange;
        }
     }

   return rangeLow;
  }
//+------------------------------------------------------------------+
